﻿using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Data;
using System.Windows.Data;

namespace CustomTextBoxColumn_SL
{
	public class MyCustomTextBoxColumn: Telerik.Windows.Controls.GridViewBoundColumnBase
	{
		public override FrameworkElement CreateCellElement(GridViewCell cell, object dataItem)
		{
			cell.GotFocus += new RoutedEventHandler(cell_GotFocus);
			TextBox txtBox = cell.Content as TextBox;
			if (txtBox == null)
			{
				txtBox = new TextBox();
				txtBox.SetBinding(TextBox.TextProperty, this.CreateValueBinding());
			}
			return txtBox;
		}

		void cell_GotFocus(object sender, RoutedEventArgs e)
		{
			(sender as GridViewCell).ChildrenOfType<TextBox>().First().Focus();
		}


		private Binding CreateValueBinding()
		{
			var valueBinding = new Binding();
			valueBinding.Mode = BindingMode.TwoWay;
			valueBinding.NotifyOnValidationError = true;
			valueBinding.ValidatesOnExceptions = true;
			valueBinding.UpdateSourceTrigger = UpdateSourceTrigger.Explicit;
			valueBinding.Path = new PropertyPath(this.DataMemberBinding.Path.Path);
			return valueBinding;
		}
	}
}
